diff -r -C 2 -P ../AmiPhone_1.92/amiphone.c ./amiphone.c
*** ../AmiPhone_1.92/amiphone.c	Sat Nov 16 23:46:46 1996
--- ./amiphone.c	Tue Mar  3 09:05:11 1998
***************
*** 1,3 ****
--- 1,4 ----
  /* AmiPhone!  by Jeremy Friesner - jfriesne@ucsd.edu */
+ /* :ts=4 */
  
  #define INTUI_V36_NAMES_ONLY
***************
*** 35,38 ****
--- 36,40 ----
  #include <errno.h>
  #include <inetd.h>
+ #include <sys/errno.h>
  
  #include <clib/alib_protos.h>
***************
*** 49,55 ****
  #include <pragmas/ahi_pragmas.h>
  
! #include "toccata/include/libraries/toccata.h"
! #include "toccata/include/clib/toccata_protos.h"
! #include "toccata/include/pragmas/toccata_pragmas.h"
  
  #include "phonerexx.h"
--- 51,59 ----
  #include <pragmas/ahi_pragmas.h>
  
! #include <libraries/toccata.h>
! #include <clib/toccata_protos.h>
! #include <pragmas/toccata_pragmas.h>
! 
! void kprintf(char *, ...);
  
  #include "phonerexx.h"
***************
*** 66,72 ****
  #include "stringrequest.h"
  #include "TCPQueue.h"
- #include "delfph.h"
- 
- #define EWOULDBLOCK     35
  
  #define IMAGE_QUIET	0
--- 70,73 ----
***************
*** 135,202 ****
  /* menus */
  struct NewMenu nmMenus[] = {
! 	NM_TITLE, "Project",         NULL,  0L,     	NULL, NULL,
! 	NM_ITEM,  "About",            "?",  0L,     	NULL, (void *) P_ABOUT,
! 	NM_ITEM,  NM_BARLABEL,       NULL,  0L,     	NULL, NULL,
! 	NM_ITEM,  "Quit",             "Q",  0L,     	NULL, (void *) P_QUIT,
! 	NM_TITLE, "TCP",             NULL,  0L,    	NULL, NULL,
! 	NM_ITEM,  "Connect To",      NULL,  0L,     	NULL, NULL,
! 	NM_SUB,   "",   	      "1",  0L,   	NULL, (void *) (T_CONNECTTO+0),
! 	NM_SUB,   "",		      "2",  0L,   	NULL, (void *) (T_CONNECTTO+1),
! 	NM_SUB,   "",   	      "3",  0L,   	NULL, (void *) (T_CONNECTTO+2),
! 	NM_SUB,   "",                 "4",  0L,   	NULL, (void *) (T_CONNECTTO+3),
! 	NM_SUB,   "",                 "5",  0L,   	NULL, (void *) (T_CONNECTTO+4),
! 	NM_SUB,   "",                 "6",  0L,   	NULL, (void *) (T_CONNECTTO+5),
! 	NM_SUB,   "",                 "7",  0L,   	NULL, (void *) (T_CONNECTTO+6),
! 	NM_SUB,   "",                 "8",  0L,   	NULL, (void *) (T_CONNECTTO+7),
! 	NM_SUB,   "",                 "9",  0L,   	NULL, (void *) (T_CONNECTTO+8),
! 	NM_SUB,   "",                 "0",  0L,   	NULL, (void *) (T_CONNECTTO+9),
! 	NM_ITEM,  "Connect",          "C",  0L,     	NULL, (void *) T_CONNECT,
! 	NM_ITEM,  "Disconnect",       "D",  0L,     	NULL, (void *) T_DISCONNECT,
! 	NM_ITEM,   "Show Daemon",     "S",  CHECKIT,    NULL, (void *) T_SHOWDAEMON,
! 	NM_TITLE, "Messages",	     NULL,  0L,         NULL, NULL,
! 	NM_ITEM,  "Messages...",      "M",  0L,         NULL, (void *) M_MESSAGES,
! 	NM_ITEM,  "Play Sound File",  "P",  0L,         NULL, (void *) M_PLAYFILE,
! 	NM_ITEM,  "Record Memo",      "W",  CHECKIT,    NULL, (void *) M_RECORDMEMO,
! 	NM_TITLE, "Settings",        NULL,  0L,     	NULL, NULL,
! 	NM_ITEM,  "Sampler",	     NULL,  0L,         NULL, NULL,
! 	NM_SUB,   "DSS8",	     NULL,  CHECKIT,    NULL, (void *) S_DSS8,
! 	NM_SUB,   "PerfectSound",    NULL,  CHECKIT,    NULL, (void *) S_PERFECTSOUND,
! 	NM_SUB,   "AMAS",	     NULL,  CHECKIT,    NULL, (void *) S_AMAS,
! 	NM_SUB,   "Sound Magic",     NULL,  CHECKIT,    NULL, (void *) S_SOMAGIC,
! 	NM_SUB,   "Toccata",         NULL,  CHECKIT,    NULL, (void *) S_TOCCATA,
! 	NM_SUB,   "Aura PCMCIA",     NULL,  CHECKIT,    NULL, (void *) S_AURA,
! 	NM_SUB,   "AHI Device",      NULL,  CHECKIT,    NULL, (void *) S_AHI,
! 	NM_SUB,   "Delfina",         NULL,  CHECKIT,    NULL, (void *) S_DELFINA,
! 	NM_SUB,   "Custom",	     NULL,  CHECKIT,    NULL, (void *) S_CUSTOM,
! 	NM_SUB,   "Generic",         NULL,  CHECKIT,    NULL, (void *) S_GENERIC,	
! 	NM_ITEM,  "Compression",     NULL,  0L,	        NULL, NULL,	
! 	NM_SUB,   "ADPCM2",           "U",  CHECKIT,    NULL, (void *) S_ADPCM2,
! 	NM_SUB,   "ADPCM3",           "I",  CHECKIT,    NULL, (void *) S_ADPCM3,
! 	NM_SUB,   "None",             "O",  CHECKIT,    NULL, (void *) S_NOCOMP,
! 	NM_ITEM,  "Transmit Enable", NULL,  0L,		NULL, NULL,	
! 	NM_SUB,   "Toggle",           "T",  CHECKIT,    NULL, (void *) S_TOGGLE,
! 	NM_SUB,   "Hold to Transmit", "H",  CHECKIT,    NULL, (void *) S_HOLD,
! 	NM_ITEM,  "Line Gain",       NULL,  0L,		NULL, NULL,	
! 	NM_SUB,   "Raise",            "]",  0L,    	NULL, (void *) S_RAISELINEGAIN,
! 	NM_SUB,   "Lower",            "[",  0L,    	NULL, (void *) S_LOWERLINEGAIN,
! 	NM_ITEM,  "Microphone Gain", NULL,  0L,		NULL, NULL,
! 	NM_SUB,   "+20 dB",           "}",  CHECKIT,   	NULL, (void *) S_TWENTYMICGAIN,
! 	NM_SUB,   "+0 dB",            "{",  CHECKIT,   	NULL, (void *) S_ZEROMICGAIN,	
! 	NM_ITEM,  "Digital Amplify", NULL,  0L,         NULL, NULL,
! 	NM_SUB,   "1X",	             NULL,  CHECKIT,    NULL, (void *) S_AMPONE,
! 	NM_SUB,   "2X",	             NULL,  CHECKIT,    NULL, (void *) S_AMPTWO,
! 	NM_SUB,   "4X",	             NULL,  CHECKIT,    NULL, (void *) S_AMPFOUR,
! 	NM_ITEM,  "Input Channel",   NULL,  0L,		NULL, NULL,		
! 	NM_SUB,   "Left",             "L",  CHECKIT,   	NULL, (void *) S_LEFTCHANNEL,
! 	NM_SUB,   "Right",            "R",  CHECKIT,   	NULL, (void *) S_RIGHTCHANNEL,
! 	NM_ITEM,  "Input Source",    NULL,  0L,		NULL, NULL,	
! 	NM_SUB,   "Microphone",       "-",  CHECKIT,   	NULL, (void *) S_INPUTMIC,
! 	NM_SUB,   "Line",             "=",  CHECKIT,   	NULL, (void *) S_INPUTEXT,
! 	NM_ITEM,  "Enable on Connect","X",  CHECKIT,    NULL, (void *) S_ENABLEONCONN,
! 	NM_ITEM,  "Xmit on Play",     "Y",  CHECKIT,    NULL, (void *) S_XMITONPLAY,
! 	NM_ITEM,  "TCP Batch Xmit",   "B",  CHECKIT,    NULL, (void *) S_TCPBATCHXMIT,
! 	NM_END,   NULL,		     NULL,  NULL,   	NULL, NULL
  };
  
  
  /* private functions */
--- 136,238 ----
  /* menus */
  struct NewMenu nmMenus[] = {
! 	NM_TITLE, "Project",		 NULL,	0L,			NULL, NULL,
! 	NM_ITEM,  "About",			  "?",	0L,			NULL, (void *) P_ABOUT,
! 	NM_ITEM,  NM_BARLABEL,		 NULL,	0L,			NULL, NULL,
! 	NM_ITEM,  "Quit",			  "Q",	0L,			NULL, (void *) P_QUIT,
! 	NM_TITLE, "TCP",			 NULL,	0L,			NULL, NULL,
! 	NM_ITEM,  "Connect To",		 NULL,	0L,			NULL, NULL,
! 	NM_SUB,	  "",				  "1",	0L,			NULL, (void *) (T_CONNECTTO+0),
! 	NM_SUB,	  "",				  "2",	0L,			NULL, (void *) (T_CONNECTTO+1),
! 	NM_SUB,	  "",				  "3",	0L,			NULL, (void *) (T_CONNECTTO+2),
! 	NM_SUB,	  "",				  "4",	0L,			NULL, (void *) (T_CONNECTTO+3),
! 	NM_SUB,	  "",				  "5",	0L,			NULL, (void *) (T_CONNECTTO+4),
! 	NM_SUB,	  "",				  "6",	0L,			NULL, (void *) (T_CONNECTTO+5),
! 	NM_SUB,	  "",				  "7",	0L,			NULL, (void *) (T_CONNECTTO+6),
! 	NM_SUB,	  "",				  "8",	0L,			NULL, (void *) (T_CONNECTTO+7),
! 	NM_SUB,	  "",				  "9",	0L,			NULL, (void *) (T_CONNECTTO+8),
! 	NM_SUB,	  "",				  "0",	0L,			NULL, (void *) (T_CONNECTTO+9),
! 	NM_ITEM,  "Connect",		  "C",	0L,			NULL, (void *) T_CONNECT,
! 	NM_ITEM,  "Disconnect",		  "D",	0L,			NULL, (void *) T_DISCONNECT,
! 	NM_ITEM,   "Show Daemon",	  "S",	CHECKIT,	NULL, (void *) T_SHOWDAEMON,
! 	NM_TITLE, "Messages",		 NULL,	0L,			NULL, NULL,
! 	NM_ITEM,  "Messages...",	  "M",	0L,			NULL, (void *) M_MESSAGES,
! 	NM_ITEM,  "Play Sound File",  "P",	0L,			NULL, (void *) M_PLAYFILE,
! 	NM_ITEM,  "Record Memo",	  "W",	CHECKIT,	NULL, (void *) M_RECORDMEMO,
! 	NM_TITLE, "Settings",		 NULL,	0L,			NULL, NULL,
! 	NM_ITEM,  "Sampler",		 NULL,	0L,			NULL, NULL,
! 	NM_SUB,	  "DSS8",			 NULL,	CHECKIT,	NULL, (void *) S_DSS8,
! 	NM_SUB,	  "PerfectSound",	 NULL,	CHECKIT,	NULL, (void *) S_PERFECTSOUND,
! 	NM_SUB,	  "AMAS",			 NULL,	CHECKIT,	NULL, (void *) S_AMAS,
! 	NM_SUB,	  "Sound Magic",	 NULL,	CHECKIT,	NULL, (void *) S_SOMAGIC,
! 	NM_SUB,	  "Toccata",		 NULL,	CHECKIT,	NULL, (void *) S_TOCCATA,
! 	NM_SUB,	  "Aura PCMCIA",	 NULL,	CHECKIT,	NULL, (void *) S_AURA,
! 	NM_SUB,	  "AHI Device",		 NULL,	CHECKIT,	NULL, (void *) S_AHI,
! 	NM_SUB,	  "Custom",			 NULL,	CHECKIT,	NULL, (void *) S_CUSTOM,
! 	NM_SUB,	  "Generic",		 NULL,	CHECKIT,	NULL, (void *) S_GENERIC,
! 	NM_SUB,	  NM_BARLABEL,		 NULL,	0L,			NULL, NULL,
! 	NM_SUB,	  "AHI Mode...",	 NULL,	0L,			NULL, (void *) S_AHIMODE,
! 
! 	NM_ITEM,  "Compression",	 NULL,	0L,			NULL, NULL, 
! 	NM_SUB,	  "ADPCM2",			  "U",	CHECKIT,	NULL, (void *) S_ADPCM2,
! 	NM_SUB,	  "ADPCM3",			  "I",	CHECKIT,	NULL, (void *) S_ADPCM3,
! 	NM_SUB,	  "None",			  "O",	CHECKIT,	NULL, (void *) S_NOCOMP,
! 	NM_ITEM,  "Transmit Enable", NULL,	0L,			NULL, NULL, 
! 	NM_SUB,	  "Toggle",			  "T",	CHECKIT,	NULL, (void *) S_TOGGLE,
! 	NM_SUB,	  "Hold to Transmit", "H",	CHECKIT,	NULL, (void *) S_HOLD,
! 	NM_ITEM,  "Line Gain",		 NULL,	0L,			NULL, NULL, 
! 	NM_SUB,	  "Raise",			  "]",	0L,			NULL, (void *) S_RAISELINEGAIN,
! 	NM_SUB,	  "Lower",			  "[",	0L,			NULL, (void *) S_LOWERLINEGAIN,
! 	NM_ITEM,  "Microphone Gain", NULL,	0L,			NULL, NULL,
! 	NM_SUB,	  "+20 dB",			  "}",	CHECKIT,	NULL, (void *) S_TWENTYMICGAIN,
! 	NM_SUB,	  "+0 dB",			  "{",	CHECKIT,	NULL, (void *) S_ZEROMICGAIN,	
! 	NM_ITEM,  "Digital Amplify", NULL,	0L,			NULL, NULL,
! 	NM_SUB,	  "1X",				 NULL,	CHECKIT,	NULL, (void *) S_AMPONE,
! 	NM_SUB,	  "2X",				 NULL,	CHECKIT,	NULL, (void *) S_AMPTWO,
! 	NM_SUB,	  "4X",				 NULL,	CHECKIT,	NULL, (void *) S_AMPFOUR,
! 	NM_ITEM,  "Input Channel",	 NULL,	0L,			NULL, NULL,		
! 	NM_SUB,	  "Left",			  "L",	CHECKIT,	NULL, (void *) S_LEFTCHANNEL,
! 	NM_SUB,	  "Right",			  "R",	CHECKIT,	NULL, (void *) S_RIGHTCHANNEL,
! 	NM_ITEM,  "Input Source",	 NULL,	0L,			NULL, NULL, 
! 	NM_SUB,	  "",		 		 "-",	CHECKIT,	NULL, (void *) S_INPUTSRC0,
! 	NM_SUB,	  "",				  "=",	CHECKIT,	NULL, (void *) S_INPUTSRC1,
! 	NM_SUB,	  "",				 NULL,	CHECKIT,	NULL, (void *) S_INPUTSRC2,
! 	NM_SUB,   "",				 NULL,	CHECKIT,	NULL, (void *) S_INPUTSRC3,
! 	NM_SUB,   "",				 NULL,	CHECKIT,	NULL, (void *) S_INPUTSRC4,
! 	NM_SUB,   "",				 NULL,	CHECKIT,	NULL, (void *) S_INPUTSRC5,
! 	NM_SUB,   "",				 NULL,	CHECKIT,	NULL, (void *) S_INPUTSRC6,
! 	NM_SUB,   "",				 NULL,	CHECKIT,	NULL, (void *) S_INPUTSRC7,
! 	NM_SUB,   "",				 NULL,	CHECKIT,	NULL, (void *) S_INPUTSRC8,
! 	NM_SUB,   "",				 NULL,	CHECKIT,	NULL, (void *) S_INPUTSRC9,
! 	NM_ITEM,  "Enable on Connect","X",	CHECKIT,	NULL, (void *) S_ENABLEONCONN,
! 	NM_ITEM,  "Xmit on Play",	  "Y",	CHECKIT,	NULL, (void *) S_XMITONPLAY,
! 	NM_ITEM,  "TCP Batch Xmit",	  "B",	CHECKIT,	NULL, (void *) S_TCPBATCHXMIT,
! 	NM_END,	  NULL,				 NULL,	NULL,		NULL, NULL
  };
  
+ /* inputs */
+ char input0[40] = "";
+ char input1[40] = "";
+ char input2[40] = "";
+ char input3[40] = "";
+ char input4[40] = "";
+ char input5[40] = "";
+ char input6[40] = "";
+ char input7[40] = "";
+ char input8[40] = "";
+ char input9[40] = "";
+ 
+ char *inputtxts[] =
+ {
+ 	input0,
+ 	input1,
+ 	input2,
+ 	input3,
+ 	input4,
+ 	input5,
+ 	input6,
+ 	input7,
+ 	input8,
+ 	input9,
+ };
  
  /* private functions */
***************
*** 215,219 ****
  
  /* private file-global data */
! static char [] = VERSION_STRING;
  static struct AmiPhoneInfo defMsg;
  static char szExitMessage[50] = "Error Initializing";
--- 251,255 ----
  
  /* private file-global data */
! static char my_version[] = AMIPHONE_VERSION;
  static struct AmiPhoneInfo defMsg;
  static char szExitMessage[50] = "Error Initializing";
***************
*** 224,228 ****
  static char * szPhoneFileName = NULL;
  static char szWinTitle[130] = "";
! static struct Gadget *glist=NULL, *gad=NULL, *freqslider=NULL, *volslider=NULL, *delayslider=NULL;
  static struct NewGadget ng;
  static struct MsgPort * AppWindowPort = NULL;
--- 260,264 ----
  static char * szPhoneFileName = NULL;
  static char szWinTitle[130] = "";
! static struct Gadget *glist=NULL, *gad=NULL, *volslider=NULL, *delayslider=NULL;
  static struct NewGadget ng;
  static struct MsgPort * AppWindowPort = NULL;
***************
*** 232,236 ****
  
  /* global vars */
! struct AmiPhoneInfo * daemonInfo = &defMsg;		
  
  /* AHI stuff? */
--- 268,275 ----
  
  /* global vars */
! struct AmiPhoneInfo * daemonInfo = &defMsg;
! struct Gadget *freqslider=NULL;
! 
! BOOL BUpdateMenus = TRUE;
  
  /* AHI stuff? */
***************
*** 247,251 ****
  struct Library * RexxSysBase   = NULL;
  struct Library * TimerBase     = NULL;
! struct Library * IntuitionBase = NULL;
  struct Library * SocketBase    = NULL;
  struct Library * GraphicsBase  = NULL;
--- 286,290 ----
  struct Library * RexxSysBase   = NULL;
  struct Library * TimerBase     = NULL;
! struct IntuitionBase * IntuitionBase = NULL;
  struct Library * SocketBase    = NULL;
  struct Library * GraphicsBase  = NULL;
***************
*** 255,259 ****
  struct Library * WorkbenchBase = NULL;
  struct Library * DiskFontBase  = NULL;
- extern struct Library * DelfinaBase;
  
  struct Library * MiscBase      = NULL;	/* this one not alloced with the others... */
--- 294,297 ----
***************
*** 299,302 ****
--- 337,341 ----
  char * pszCallNames[] = {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};
  char * pszCallIPs[]   = {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};
+ ULONG ulAHIMode = AHI_DEFAULT_ID;
  int windowtop=-1, windowleft=-1, nSendPri = 999, nReceivePri = 1, nToggleMode = TOGGLE_TOGGLE, nSampleTechnique = TECHNIQUE_HARDINT;
  ULONG ulSampleArraySize; 
***************
*** 327,336 ****
  extern struct IntInfo IntData;
  extern BYTE sighalf, sigfull;
! extern __chip unsigned short microphone_image[];
  extern UBYTE * pubAllocedArray, * pubRightBuffer;
  extern struct AmiPhonePacketHeader * TransmitPacket[2];
  extern LONG sTCPSocket;
! extern char szLastMemoFile[200] = "(unset)";
! extern int delfsig, nMicGainValue;
  
  /* Data to use after we get a CTRL-F from the Toccata Capture interrupt */
--- 366,375 ----
  extern struct IntInfo IntData;
  extern BYTE sighalf, sigfull;
! extern CHIP unsigned short microphone_image[];
  extern UBYTE * pubAllocedArray, * pubRightBuffer;
  extern struct AmiPhonePacketHeader * TransmitPacket[2];
  extern LONG sTCPSocket;
! extern char szLastMemoFile[200]; /* = "(unset)"; */
! extern int nMicGainValue;
  
  /* Data to use after we get a CTRL-F from the Toccata Capture interrupt */
***************
*** 363,368 ****
  BOOL UsesCIAInterrupt(void)
  {
! 	return((ubSamplerType != SAMPLER_DELFINA) &&
! 	       (ubSamplerType != SAMPLER_AHI) &&
  	       (ubSamplerType != SAMPLER_TOCCATA));
  }
--- 402,406 ----
  BOOL UsesCIAInterrupt(void)
  {
! 	return((ubSamplerType != SAMPLER_AHI) &&
  	       (ubSamplerType != SAMPLER_TOCCATA));
  }
***************
*** 377,381 ****
  	return((ubSamplerType == SAMPLER_PERFECT) ||
  	       (ubSamplerType == SAMPLER_TOCCATA) ||
- 	       (ubSamplerType == SAMPLER_DELFINA) ||
  	       (ubSamplerType == SAMPLER_GVPDSS8));
  }
--- 415,418 ----
***************
*** 383,388 ****
  BOOL CanAdjustMicGain(void)
  {
! 	return((ubSamplerType == SAMPLER_TOCCATA) ||
! 	       (ubSamplerType == SAMPLER_DELFINA));
  }
  
--- 420,424 ----
  BOOL CanAdjustMicGain(void)
  {
! 	return((ubSamplerType == SAMPLER_TOCCATA));
  }
  
***************
*** 391,396 ****
  	return((ubSamplerType == SAMPLER_SOMAGIC) ||
  	       (ubSamplerType == SAMPLER_CUSTOM)  ||
! 	       (ubSamplerType == SAMPLER_DELFINA) ||
! 	       (ubSamplerType == SAMPLER_TOCCATA));
  }
  
--- 427,432 ----
  	return((ubSamplerType == SAMPLER_SOMAGIC) ||
  	       (ubSamplerType == SAMPLER_CUSTOM)  ||
! 	       (ubSamplerType == SAMPLER_TOCCATA) ||
! 	       (ubSamplerType == SAMPLER_AHI));
  }
  
***************
*** 402,405 ****
--- 438,460 ----
  
  
+ LONG SAVEDS STDARGS FreqSliderFunc(struct Gadget *gadget, WORD level)
+ {
+ 
+ 	if((gadget != freqslider) || (AHIBase == NULL) || (ubSamplerType != SAMPLER_AHI))
+ 	{
+ 		return level;
+ 	}
+ 	else
+ 	{
+ 		ULONG freq = 0;
+ 		
+ 		AHI_GetAudioAttrs(ulAHIMode, NULL,
+ 			AHIDB_FrequencyArg,	level,
+ 			AHIDB_Frequency,	&freq,
+ 			TAG_DONE);
+ 
+ 		return freq;
+ 	}
+ }
  
  BOOL AllocSliders(BOOL BAlloc)
***************
*** 451,454 ****
--- 506,510 ----
  			GTSL_Level,		(WORD)ulBytesPerSecond,
  			GTSL_LevelFormat, 	szLevelString1,
+ 			GTSL_DispFunc,		FreqSliderFunc,
  			GTSL_LevelPlace,	PLACETEXT_RIGHT,
  			GTSL_MaxLevelLen,	7+(nMaxSampleRate >= 10000)+(BPropFont*2),
***************
*** 561,567 ****
  	if (strcmp(szParam,"AURA") == 0)    return(SAMPLER_AURA);
  
- 	/* Delfina board. */
- 	if ((DelfinaBase)&&(strcmp(szParam,"DELFINA") == 0)) return(SAMPLER_DELFINA);
- 
  	/* The AHI Device sound API */
  	if ((AHIBase)&&(strncmp(szParam,"AHI",3) == 0))  return(SAMPLER_AHI);
--- 617,620 ----
***************
*** 587,591 ****
  		case SAMPLER_SOMAGIC:	szType = "SOUNDMAGIC"; break;
  		case SAMPLER_AURA:	szType = "AURA";    break;
- 		case SAMPLER_DELFINA:	szType = "DELFINA"; break;
  		case SAMPLER_AHI:	szType = "AHI";	    break;
  	}
--- 640,643 ----
***************
*** 794,805 ****
--- 846,934 ----
  BOOL CreatePhoneMenus(BOOL BCreate)
  {   
+ 	struct NewMenu *newmenu;
+ 	ULONG inputs = 0;
+ 
  	void * VisualInfo = NULL;
  
  	if (BCreate == FALSE) 
  	{
+ 		if(PhoneWindow) ClearMenuStrip(PhoneWindow);
  		if (Menu) {FreeMenus(Menu); Menu = NULL;}
  		return(TRUE);
  	}
  
+ 	if(ubSamplerType == SAMPLER_AHI && AHIBase != NULL)
+ 	{
+ 		AHI_GetAudioAttrs(ulAHIMode, NULL,
+ 			AHIDB_Inputs,	&inputs,
+ 			TAG_DONE);
+ 	}
+ 	else
+ 	{
+ 		inputs = 2;
+ 	}
+ 
+ 	newmenu = nmMenus;
+ 
+ 
+ 	while(newmenu->nm_Type != NM_END)
+ 	{
+ 		int i;
+ 	
+ 
+ 		switch((ULONG) newmenu->nm_UserData)
+ 		{
+ 			case S_INPUTSRC0:
+ 			case S_INPUTSRC1:
+ 			case S_INPUTSRC2:
+ 			case S_INPUTSRC3:
+ 			case S_INPUTSRC4:
+ 			case S_INPUTSRC5:
+ 			case S_INPUTSRC6:
+ 			case S_INPUTSRC7:
+ 			case S_INPUTSRC8:
+ 			case S_INPUTSRC9:
+ 				i = ((ULONG) newmenu->nm_UserData - S_INPUTSRC0);
+ 				
+ 				if(i < inputs)
+ 				{
+ 					if(ubSamplerType == SAMPLER_AHI && AHIBase != NULL)
+ 					{
+ 						AHI_GetAudioAttrs(ulAHIMode, NULL,
+ 							AHIDB_BufferLen,	40,
+ 							AHIDB_InputArg,		i,
+ 							AHIDB_Input,		inputtxts[i],
+ 							TAG_DONE);
+ 						newmenu->nm_Label = inputtxts[i];
+ 					}
+ 					else
+ 					{
+ 						if(i == 0) newmenu->nm_Label = "Microphone";
+ 						else if(i == 1) newmenu->nm_Label = "Line";
+ 						else newmenu->nm_Label = "????";
+ 					}
+ 
+ 					newmenu->nm_Type  &= ~NM_IGNORE;
+ 					newmenu->nm_Flags &= ~NM_ITEMDISABLED;
+ 				}
+ 				else
+ 				{
+ 					newmenu->nm_Type  |= NM_IGNORE;
+ 					newmenu->nm_Label = "";
+ 					newmenu->nm_Flags |= NM_ITEMDISABLED;
+ 				}
+ 
+ 				if(i == 0 && inputs == 0)
+ 				{
+ 					newmenu->nm_Label = "None";
+ 					newmenu->nm_Type  &= ~NM_IGNORE;
+ 					newmenu->nm_Flags &= ~NM_ITEMDISABLED;
+ 				}
+ 
+ 				break;
+ 		}
+ 		newmenu++;
+ 	}
+ 
  	/* Create menus */
  	UNLESS(Menu = CreateMenus(nmMenus, TAG_DONE))
***************
*** 815,819 ****
  	}
  	
! 	if (LayoutMenus(Menu, VisualInfo, TAG_DONE))
  	{
  		SetMenuStrip(PhoneWindow, Menu);
--- 944,948 ----
  	}
  	
! 	if (LayoutMenus(Menu, VisualInfo, GTMN_NewLookMenus, TRUE, TAG_DONE))
  	{
  		SetMenuStrip(PhoneWindow, Menu);
***************
*** 826,829 ****
--- 955,961 ----
  	}
  	FreeVisualInfo(VisualInfo);
+ 
+ 	SetMenuValues();
+ 
  	return(TRUE);
  }
***************
*** 881,885 ****
  	const int diff = 'a' - 'A';
  
! 	UNLESS(sOldString) return();
  	
  	while (*i != '\0')
--- 1013,1017 ----
  	const int diff = 'a' - 'A';
  
! 	UNLESS(sOldString) return;
  	
  	while (*i != '\0')
***************
*** 897,901 ****
  	const int diff = 'a' - 'A';
  
! 	UNLESS(sOldString) return();
  	while (*i != '\0')
   	{
--- 1029,1033 ----
  	const int diff = 'a' - 'A';
  
! 	UNLESS(sOldString) return;
  	while (*i != '\0')
   	{
***************
*** 972,987 ****
  		  	UNCHECKSUB;
  		  }
- 	NEXTSUB;  if (DelfinaBase)
- 		  {
- 		  	ENABLESUB;
- 		  	if (ubSamplerType == SAMPLER_DELFINA) CHECKSUB; else UNCHECKSUB;
- 		  }
- 		  else
- 		  {
- 		  	DISABLESUB;
- 		  	UNCHECKSUB;
- 		  }
  	NEXTSUB;  if (ubSamplerType == SAMPLER_CUSTOM)  CHECKSUB; else UNCHECKSUB;
  	NEXTSUB;  if (ubSamplerType == SAMPLER_GENERIC) CHECKSUB; else UNCHECKSUB;
  
  	/* compression submenu */
--- 1104,1112 ----
  		  	UNCHECKSUB;
  		  }
  	NEXTSUB;  if (ubSamplerType == SAMPLER_CUSTOM)  CHECKSUB; else UNCHECKSUB;
  	NEXTSUB;  if (ubSamplerType == SAMPLER_GENERIC) CHECKSUB; else UNCHECKSUB;
+ 	NEXTSUB;  /* BARLABEL */
+ 	NEXTSUB;  if (ubSamplerType == SAMPLER_AHI) ENABLESUB; else DISABLESUB;
+ 
  
  	/* compression submenu */
***************
*** 1017,1022 ****
  	/* Input source submenu */
  	NEXTITEM; if (CanAdjustInputSource()) ENABLEITEM; else DISABLEITEM;
! 	FIRSTSUB; if (ubInputSource == INPUT_SOURCE_MIC) CHECKSUB; else UNCHECKSUB;
! 	NEXTSUB;  if (ubInputSource == INPUT_SOURCE_EXT) CHECKSUB; else UNCHECKSUB;
  	
  	/* Xmit on connect */
--- 1142,1152 ----
  	/* Input source submenu */
  	NEXTITEM; if (CanAdjustInputSource()) ENABLEITEM; else DISABLEITEM;
! 	FIRSTSUB; if (ubInputSource == INPUT_SOURCE_0) CHECKSUB; else UNCHECKSUB;
! 	for (i=1;i<10;i++) 
! 	{
! 		if(currentSub->NextItem == NULL) break;
! 
! 		NEXTSUB;  if (ubInputSource == i) CHECKSUB; else UNCHECKSUB;
! 	}
  	
  	/* Xmit on connect */
***************
*** 1149,1153 ****
  				{
  					case FREQ_SLIDER:
! 						/* everything is done below for us! */
  						break;
  						
--- 1279,1296 ----
  				{
  					case FREQ_SLIDER:
! 						if((AHIBase == NULL) || (ubSamplerType != SAMPLER_AHI))
! 						{
! 							/* everything is done below for us! */
! 						}
! 						else
! 						{
! 							LONG freq = 0;
! 
! 							AHI_GetAudioAttrs(ulAHIMode, NULL,
! 								AHIDB_FrequencyArg,	code,
! 								AHIDB_Frequency,	&freq,
! 								TAG_DONE);
! 							code = freq;
! 						}
  						break;
  						
***************
*** 1163,1168 ****
  						break;
  				}
! 				GT_SetGadgetAttrs(freqslider,PhoneWindow,NULL,GTSL_Level, 
! 				       ChangeSampleSpeed(code,ubCurrComp), TAG_END);
  				break;
  
--- 1306,1328 ----
  						break;
  				}
! 
! 				if((AHIBase == NULL) || (ubSamplerType != SAMPLER_AHI))
! 				{
! 					GT_SetGadgetAttrs(freqslider,PhoneWindow,NULL,GTSL_Level, 
! 					       ChangeSampleSpeed(code,ubCurrComp), TAG_END);
! 				}
! 				else
! 				{
! 					LONG index = 0;
! 
! 					AHI_GetAudioAttrs(ulAHIMode, NULL,
! 						AHIDB_IndexArg,	ChangeSampleSpeed(code,ubCurrComp),
! 						AHIDB_Index,	&index,
! 						TAG_DONE);
! 
! 					GT_SetGadgetAttrs(freqslider,PhoneWindow,NULL,GTSL_Level, 
! 					       index, TAG_END);
! 				}
! 
  				break;
  
***************
*** 1183,1187 ****
  			case IDCMP_CLOSEWINDOW: 
  				SetExitMessage("Window Closed",0);
! 				BProgramDone = TRUE;  
  				break;
  				
--- 1343,1347 ----
  			case IDCMP_CLOSEWINDOW: 
  				SetExitMessage("Window Closed",0);
! 				BProgramDone = TRUE;
  				break;
  				
***************
*** 1222,1225 ****
--- 1382,1436 ----
  					}
  				}
+ 				else if (ubSamplerType == SAMPLER_AHI)
+ 				{
+ 					LONG index = 0, freqs = 0, freq = 0;
+ 
+ 					AHI_GetAudioAttrs(ulAHIMode, NULL,
+ 						AHIDB_IndexArg,		ulBytesPerSecond,
+ 						AHIDB_Index,		&index,
+ 						AHIDB_Frequencies,	&freqs,
+ 						TAG_DONE);
+ 
+ 					if ((code == '.')||(code == '>'))
+ 					{
+ 						if(index < (freqs - 1))
+ 						{
+ 							index++;
+ 						}
+ 
+ 						AHI_GetAudioAttrs(ulAHIMode, NULL,
+ 							AHIDB_FrequencyArg,	index,
+ 							AHIDB_Frequency,	&freq,
+ 							TAG_DONE);
+ 
+ 
+ 						if(freq <= nMaxSampleRate)
+ 						{
+ 							ChangeSampleSpeed(freq, ubCurrComp);
+ 
+ 							GT_SetGadgetAttrs(freqslider,PhoneWindow,NULL,
+ 								GTSL_Level, index,
+ 								TAG_END);
+ 						}
+ 					}
+ 					if ((code == ',')||(code == '<'))
+ 					{
+ 						if(index > 0)
+ 						{
+ 							index--;
+ 						}
+ 
+ 						AHI_GetAudioAttrs(ulAHIMode, NULL,
+ 							AHIDB_FrequencyArg,	index,
+ 							AHIDB_Frequency,	&freq,
+ 							TAG_DONE);
+ 
+ 						ChangeSampleSpeed(freq, ubCurrComp);
+ 
+ 						GT_SetGadgetAttrs(freqslider,PhoneWindow,NULL,
+ 							GTSL_Level, index,
+ 							TAG_END);
+ 					}
+ 				}
  				else
  				{
***************
*** 1258,1262 ****
  						case M_RECORDMEMO:	StartRecording(fpMemo == NULL,NULL);break;
  						case S_DSS8:		ChangeSamplerType(SAMPLER_GVPDSS8); break;
! 						case S_PERFECTSOUND:	ChangeSamplerType(SAMPLER_PERFECT); break;
  						case S_AMAS:		ChangeSamplerType(SAMPLER_AMAS);    break;
  						case S_TOCCATA:		ChangeSamplerType(SAMPLER_TOCCATA); break;
--- 1469,1473 ----
  						case M_RECORDMEMO:	StartRecording(fpMemo == NULL,NULL);break;
  						case S_DSS8:		ChangeSamplerType(SAMPLER_GVPDSS8); break;
! 						case S_PERFECTSOUND:ChangeSamplerType(SAMPLER_PERFECT); break;
  						case S_AMAS:		ChangeSamplerType(SAMPLER_AMAS);    break;
  						case S_TOCCATA:		ChangeSamplerType(SAMPLER_TOCCATA); break;
***************
*** 1264,1270 ****
  						case S_GENERIC:		ChangeSamplerType(SAMPLER_GENERIC); break;
  						case S_AURA:		ChangeSamplerType(SAMPLER_AURA);    break;
! 						case S_AHI:		ChangeSamplerType(SAMPLER_AHI);     break;
! 						case S_DELFINA:		ChangeSamplerType(SAMPLER_DELFINA); break;
  						case S_SOMAGIC:		ChangeSamplerType(SAMPLER_SOMAGIC); break;
  						case S_ADPCM2:		ChangeCompressMode(COMPRESS_ADPCM2);break;
  						case S_ADPCM3:		ChangeCompressMode(COMPRESS_ADPCM3);break;
--- 1475,1481 ----
  						case S_GENERIC:		ChangeSamplerType(SAMPLER_GENERIC); break;
  						case S_AURA:		ChangeSamplerType(SAMPLER_AURA);    break;
! 						case S_AHI:			ChangeSamplerType(SAMPLER_AHI);     break;
  						case S_SOMAGIC:		ChangeSamplerType(SAMPLER_SOMAGIC); break;
+ 						case S_AHIMODE:		ChangeAHIMode();					break;
  						case S_ADPCM2:		ChangeCompressMode(COMPRESS_ADPCM2);break;
  						case S_ADPCM3:		ChangeCompressMode(COMPRESS_ADPCM3);break;
***************
*** 1272,1281 ****
  						case S_TOGGLE:		nToggleMode = TOGGLE_TOGGLE;    break;
  						case S_HOLD:		nToggleMode = TOGGLE_HOLD; ToggleMicButton(CODE_OFF); break;
! 						case S_ENABLEONCONN:	BEnableOnConnect = Not[BEnableOnConnect];	   break;
  						case S_XMITONPLAY:	BXmitOnPlay      = Not[BXmitOnPlay];	   break;
! 						case S_TCPBATCHXMIT:	BTCPBatchXmit    = Not[BTCPBatchXmit]; break;
! 						case S_RAISELINEGAIN:	RaiseLineGain(1);		     break;
! 						case S_LOWERLINEGAIN:	RaiseLineGain(-1);	   	     break;
! 						case S_TWENTYMICGAIN:   SetMicGain(20);			     break;
  						case S_ZEROMICGAIN:	SetMicGain(0);			     break;
  						case S_AMPONE:		nAmpShift = 0; IntData.ulShiftLeft = 0L; break;
--- 1483,1492 ----
  						case S_TOGGLE:		nToggleMode = TOGGLE_TOGGLE;    break;
  						case S_HOLD:		nToggleMode = TOGGLE_HOLD; ToggleMicButton(CODE_OFF); break;
! 						case S_ENABLEONCONN:BEnableOnConnect = Not[BEnableOnConnect];	   break;
  						case S_XMITONPLAY:	BXmitOnPlay      = Not[BXmitOnPlay];	   break;
! 						case S_TCPBATCHXMIT:BTCPBatchXmit    = Not[BTCPBatchXmit]; break;
! 						case S_RAISELINEGAIN:RaiseLineGain(1);		     break;
! 						case S_LOWERLINEGAIN:RaiseLineGain(-1);	   	     break;
! 						case S_TWENTYMICGAIN:SetMicGain(20);		     break;
  						case S_ZEROMICGAIN:	SetMicGain(0);			     break;
  						case S_AMPONE:		nAmpShift = 0; IntData.ulShiftLeft = 0L; break;
***************
*** 1283,1289 ****
  						case S_AMPFOUR:		nAmpShift = 2; IntData.ulShiftLeft = 2L; break;
  						case S_LEFTCHANNEL:	ChangeInputChannel(INPUT_JACK_LEFT); break;
! 						case S_RIGHTCHANNEL:	ChangeInputChannel(INPUT_JACK_RIGHT); break;
! 						case S_INPUTMIC:        ChangeInputSource(INPUT_SOURCE_MIC,TRUE); break;
! 						case S_INPUTEXT:        ChangeInputSource(INPUT_SOURCE_EXT,TRUE); break;
  						default: 		
  							if ((ulItemCode >= T_CONNECTTO)&&(ulItemCode <= T_CONNECTTO+9))
--- 1494,1508 ----
  						case S_AMPFOUR:		nAmpShift = 2; IntData.ulShiftLeft = 2L; break;
  						case S_LEFTCHANNEL:	ChangeInputChannel(INPUT_JACK_LEFT); break;
! 						case S_RIGHTCHANNEL:ChangeInputChannel(INPUT_JACK_RIGHT); break;
! 						case S_INPUTSRC0:
! 						case S_INPUTSRC1:
! 						case S_INPUTSRC2:
! 						case S_INPUTSRC3:
! 						case S_INPUTSRC4:
! 						case S_INPUTSRC5:
! 						case S_INPUTSRC6:
! 						case S_INPUTSRC7:
! 						case S_INPUTSRC8:
! 						case S_INPUTSRC9:   ChangeInputSource(ulItemCode-S_INPUTSRC0,TRUE); break;
  						default: 		
  							if ((ulItemCode >= T_CONNECTTO)&&(ulItemCode <= T_CONNECTTO+9))
***************
*** 1297,1300 ****
--- 1516,1520 ----
  					code = (message == fakeMessage) ? MENUNULL : mItem->NextSelect;
  				}
+ 
  				SetMenuValues();
  				break;
***************
*** 1326,1329 ****
--- 1546,1561 ----
  		message = (struct IntuiMessage *)GT_GetIMsg(PhoneWindow->UserPort);
  	}
+ 
+     if(BUpdateMenus)
+     {
+         BUpdateMenus = FALSE;
+         CreatePhoneMenus(FALSE);
+         UNLESS(CreatePhoneMenus(TRUE))
+         {
+     		SetExitMessage("Couldn't Create Menus!",RETURN_ERROR);
+     		BProgramDone = TRUE;
+         }
+     }
+ 
  	return(BProgramDone);
  }
***************
*** 1350,1355 ****
  		RexxSysBase   = OpenLibrary("rexxsyslib.library", 36L);
  		
- 		InitDelfina();	/* On success of this function, DelfinaBase is set to non-NULL */
- 		
  		AllocAHI(TRUE);
  	}
--- 1582,1585 ----
***************
*** 1357,1361 ****
  	{
  		AllocAHI(FALSE);
- 		if (DelfinaBase)	 CleanupDelfina();
  		if (ToccataBase)	 CloseLibrary(ToccataBase);
  		if (WorkbenchBase)	 CloseLibrary(WorkbenchBase);
--- 1587,1590 ----
***************
*** 1514,1524 ****
  		Forbid();
  		while(amsg = (struct AppMessage *) GetMsg(AppWindowPort)) ReplyMsg(amsg);
! 	 	Permit();
!  		DeleteMsgPort(AppWindowPort);
!  	}
!  	
! 	if (PhoneWindow) CloseWindow(PhoneWindow);
! 	
  	CreatePhoneMenus(FALSE);		
  	AllocSliders(FALSE);	
  	if (Scr) UnlockPubScreen(NULL,Scr);
--- 1743,1757 ----
  		Forbid();
  		while(amsg = (struct AppMessage *) GetMsg(AppWindowPort)) ReplyMsg(amsg);
! 		Permit();
! 		DeleteMsgPort(AppWindowPort);
! 	}
! 
  	CreatePhoneMenus(FALSE);		
+ 
+ 	if (PhoneWindow)
+ 	{
+ 		CloseWindow(PhoneWindow);
+ 	}
+ 	
  	AllocSliders(FALSE);	
  	if (Scr) UnlockPubScreen(NULL,Scr);
***************
*** 1531,1535 ****
  	{
  		if (pszCallNames[i]) FreeMem(pszCallNames[i],strlen(pszCallNames[i])+1);
! 		if (pszCallIPs[i])   FreeMem(pszCallIPs[i],  strlen(pszCallIPs[i])  +1);
  
  	}
--- 1764,1768 ----
  	{
  		if (pszCallNames[i]) FreeMem(pszCallNames[i],strlen(pszCallNames[i])+1);
! 		if (pszCallIPs[i])	 FreeMem(pszCallIPs[i],	 strlen(pszCallIPs[i])	+1);
  
  	}
***************
*** 1546,1550 ****
  LONG ChopValue(LONG ulVal, LONG ulLow, LONG ulHigh)
  {
! 	if (ulVal < ulLow)  ulVal = ulLow;
  	if (ulVal > ulHigh) ulVal = ulHigh;
  	return(ulVal);
--- 1779,1783 ----
  LONG ChopValue(LONG ulVal, LONG ulLow, LONG ulHigh)
  {
! 	if (ulVal < ulLow)	ulVal = ulLow;
  	if (ulVal > ulHigh) ulVal = ulHigh;
  	return(ulVal);
